#include <stdio.h>

#ifndef __CODECONV_H
#define __CODECONV_H
#define TRUE 1
#define FALSE 0
#define PathLen 255
#define MaxProgLine 4096
#define MaxLineLen 512
#define MaxCodeNum 1024
#define MaxCodeSetNum 65
#define MaxCodeNameLen 32
#define CodeBlkSize 512
#define MaxCodeLen 32
#define PufferLen 8192
/* mikroprogram utasitasok */
#define NemTalalt 0
#define CompGoto 1
#define CompReplace 2
#define DoGoto 3
#define DoReplace 4

#ifdef __MSDOS__
#define LDir '\\'
#else
#define LDir '/'
#include <unistd.h>
#endif

#define iswspace(c) (((c)==' ')||((c)=='\t'))
#define CommentChar '%'

typedef unsigned char byte;
typedef unsigned int word;
typedef char nev[PathLen];
typedef char fnev[13];

extern nev tabneve;				/* tablazatfile neve*/
extern char	intype[],
		outtype[];					/* ki-,bemeneti tipusnev roviditve*/
extern byte **outcod;				/* mutato a ki-kodok tablazatara */
extern int onmaga,					/* A file-t ua. neven mentsuk-e el*/
		futinfkiir,					/* Kiirjunk-e uzeneteket */
		csakkeres,			/* Csak megkeressuk, milyen kodolast hasznal */
		nemetkodok,			/* german characters also count */
		mprogram[MaxProgLine][2],
		MProgSize,
		maxcodlen,
		codn;
extern char *cname[MaxCodeSetNum],	/* kodkonvenciok nevei, */
		*cabbr[MaxCodeSetNum];		/*			roviditesei */
extern int win95;					/* win95 alol inditottak-e */
extern void Copyright(void);
extern long filesize(FILE *stream);
extern int Keresd(char *utvonal1, char *utvonal2, char *tabneve, char *befnev);
extern int Konvertal(char *befnev, char *kifnev, byte **outcod);
extern int LoadAllCodes(char *ut, char *ut2, char *tabfnev, byte ***incod,
	int *codsn,int *cod_n);
extern int LoadCodes(char *intype, char *outtype, char *ut, char *ut2,
	char *tabfnev, char *befnev, byte ***incod, byte ***outcod, int *cod_n);
extern int elobbrevalo(byte *s1, byte *s2);
extern int MakeProg(char *intype, char *outtype, byte ***outcod,
	char *ut, char *ut2, char *tabneve, char *befn);
extern int mprogram[][2];
extern int MakeSearchProg(char *ut, char *ut2, char *tabneve, int *codsn);
extern int Kezimegadas(char *intype, char *outtype);
extern int LoadNames(char *ut, char *ut2, char *tabfnev, char **cname,
	char **cabbr, int *n);
extern char *strwsp(char *s);
extern char *strdel1(char *s);
extern char *strupr(char *s);
extern char direct_getc(void);
extern FILE *ccfopen(char *fname, char *mode);
#endif
