#include <stdlib.h>
#include <string.h>
#include "codeconv.h"

elobbrevalo(byte *s1, byte *s2)
{
	while ((*s1!='\0')&&(*s2!='\0'))
	{
		if (*s1<*s2)
			return 1;
		if (*s1>*s2)
			return 0;
		s1++,s2++;
	}
	if (*s1=='\0')
		return 0;
	else
		return 1;
}
MakeProg(char *intype, char *outtype,
			byte ***outcod, char *ut, char *ut2, char *tabneve, char *befn)
{
	byte **incod;	/* bemeneti kodok tablazatara mutato */
	int	codn,i,h,j,sorrend[MaxCodeNum],MPFree;

	if (futinfkiir)
		fprintf(stderr,"makeprog\n");
	/* beto"ltjuk a ko'dokat egy ta'bla'zatba... */
	LoadCodes(intype,outtype,ut,ut2,tabneve,befn,&incod,outcod,&codn);
	/* sorbarakjuk az in-kodokat */
	if (futinfkiir)
		fprintf(stderr,"loadcodes utan\n");
	sorrend[0]=0;
	for (i=1;i<codn;i++)
	{
		j=i;
		while ((j>0)&&elobbrevalo(incod[i],incod[sorrend[j-1]]))
			j--,sorrend[j+1]=sorrend[j];
		sorrend[j]=i;		/* ..beszurasos rendezessel */
	}						/* a kodok a helyukon maradnak, hogy
	azonositani tudjuk: melyik bemenethez melyik kimenet tartozik */

	for (i=0;i<256;i++)			/* elo~szo"r kinulla'zzuk a prg. eleje't */
		mprogram[i][0]=0,mprogram[i][1]=0;	/* 0 azt jelenti: nem tala'lt */
	MPFree=256;
	for (i=0;i<codn;i++)
	{
		byte *kod;
		int k;

		kod=incod[sorrend[i]];
		if (strcmp("ss",(char*)kod))	/* az 'ss' kombinaciok nem jatszanak */
		{
			if (mprogram[kod[0]][0]==(3<<8))	/* mar volt ilyen kezdetu kod*/
			{
				k=mprogram[kod[0]][1];		/* ugrasi helyre megyunk */
				while ((mprogram[k][0]!=0)	/* utana levo ures helyre */
					&&(mprogram[k][0]!=(1<<8)+kod[1]))
					k++;					/* ill. a mar letezo ugrashoz */
			}
			else{							/* ha nem,itt irjuk bele az ugrast*/
				mprogram[kod[0]][0]=3<<8;	/* feltetel nelkuli ugras */
				mprogram[kod[0]][1]=MPFree;
				k=MPFree++;
				mprogram[k][0]=0;
				mprogram[k][1]=0;
			}
			if (mprogram[k][0]!=(1<<8)+kod[1])
			{
				if (strlen((char*)kod)==1)		/* feltetel nelkul megvan(cserelunk) */
					mprogram[k][0]=4<<8,mprogram[k][1]=sorrend[i];
				else if (strlen((char*)kod)==2)/* ha a 2.char is stimmel, cserelunk */
					mprogram[k][0]=(2<<8)+kod[1],mprogram[k][1]=sorrend[i];
				else					/* ha a 2.char is o.k., akkor tovabb */
					mprogram[k][0]=(1<<8)+kod[1],mprogram[k][1]=0;
				/* utana teszunk egy nemtalalt-at */
				mprogram[k+1][0]=0,mprogram[k+1][1]=0;
				MPFree=k+2;					/* szabad csak az utana levo */
			}
		}
	}
/* elso menet kesz, megyunk tovabb */
/* megnezzuk, legfeljebb milyen hosszuak a kodok */
	for (maxcodlen=0,i=0;i<codn;i++)
		if ((j=strlen((char*)incod[i]))>maxcodlen)
			maxcodlen=j;
/* minden koddal vegezni kell */
	for (h=2;h<maxcodlen;h++)
		for (i=0;i<codn;i++)
		{
			byte *kod;
			int k,l,m;

			kod=incod[sorrend[i]];
			if ((strlen((char*)kod)>=h)&&(strcmp("ss",(char*)kod)))
			{
				l=kod[0];	/* kiindulunk az elso karakterbol, */
				for (k=1;k<h;k++)	/* az direkt ugras */
				{
					l=mprogram[l][1];	/* ide ugrik a prog. szerint */
					for (m=l;
						(((mprogram[m][0]&0xFF)!=kod[k])||
						((mprogram[m][0]>>8)!=1))&&(mprogram[m][0]!=0);
						m++)
						;	/* megkeressuk, hol van a kov. ugras */
					l=m;
				}
				if (mprogram[l][0]!=0)		/* meg nem ert itt veget minden*/
				{
					if (mprogram[l][1]!=0)	/* mar foglalkoztunk az esettel */
					{
						l=mprogram[l][1];		/* megnezzuk, hova ugrik */
						while (mprogram[l][0]!=0)/* elmegyunk ott a vegeig */
							l++;
					}
					else
					{
						mprogram[l][1]=MPFree;	/* atallitjuk az ugrast */
						l=MPFree++;
					}
					if (strlen((char*)kod)==h)			/* csak akkor cserelunk, ha */
												/* a hosszabb kodok nem jok */
						mprogram[l][0]=(4<<8),mprogram[l][1]=sorrend[i];
					else if (strlen((char*)kod)==h+1)		/* ez mar a kod vege */
						mprogram[l][0]=(2<<8)+kod[h],mprogram[l][1]=sorrend[i];
					else					/* me'g majd tovabbmegyunk */
						mprogram[l][0]=(1<<8)+kod[h],mprogram[l][1]=0;
					mprogram[l+1][0]=0,mprogram[l+1][1]=0;
					MPFree=l+2;
				}
			}
		}
	MProgSize=MPFree;
/*	for (i=0; i<MPFree; i++)
		printf("%4d | %3d %3d %4d\n",i,mprogram[i][0]>>8,
			mprogram[i][0] & 0xff,mprogram[i][1]);*/
	free((char*)incod[0]);			/* felszabaditjuk... */
	free((char*)incod);
	return 0;
}

MakeSearchProg(char *ut, char *ut2, char *tabneve, int *codsn)
{
	byte **incod;	/* bemeneti kodok tablazatara mutato */
	int	codn,		/* codenum., codesetnum. */
		i,h,j,sorrend[MaxCodeNum],MPFree;

	/* beto"ltjuk a ko'dokat egy ta'bla'zatba... */
	LoadAllCodes(ut,ut2,tabneve,&incod,codsn,&codn);
/*	fputs("loadall utan...",stderr);*/
	/* sorbarakjuk a kodokat */
	sorrend[0]=0;
	codn*=*codsn;
	for (i=1;i<codn;i++)
	{
		j=i;
		while ((j>0)&&elobbrevalo(incod[i],incod[sorrend[j-1]]))
			j--,sorrend[j+1]=sorrend[j];
		sorrend[j]=i;		/* ..beszurasos rendezessel */
	}						/* a kodok a helyukon maradnak,
		hogy azonositani tudjuk: melyik bemenet hova tartozik */

	for (i=0;i<256;i++)			/* elo~szo"r kinulla'zzuk a prg. eleje't */
		mprogram[i][0]=0,mprogram[i][1]=0;	/* 0 azt jelenti: nem tala'lt */
	MPFree=256;
	for (i=0;i<codn;i++)
	{
		byte *kod;
		int k;

		kod=incod[sorrend[i]];
		if (strcmp("ss",(char*)kod))
		{
			if (mprogram[kod[0]][0]==(3<<8))	/* mar volt ilyen kezdetu kod*/
			{
				k=mprogram[kod[0]][1];		/* ugrasi helyre megyunk */
				while ((mprogram[k][0]!=0)	/* utana levo ures helyre */
					&&(mprogram[k][0]!=(1<<8)+kod[1]))
					k++;					/* ill. a mar letezo ugrashoz */
			}
			else{							/* ha nem,itt irjuk bele az ugrast*/
				mprogram[kod[0]][0]=3<<8;	/* feltetel nelkuli ugras */
				mprogram[kod[0]][1]=MPFree;
				k=MPFree++;
			}
			if (mprogram[k][0]!=(1<<8)+kod[1])
			{
				if (strlen((char*)kod)==1)	/* feltetel nelkul megvan
									(kodkeszlet azonositojat adjuk vissza)	*/
					mprogram[k][0]=4<<8,mprogram[k][1]=sorrend[i]%*codsn;
				else if (strlen((char*)kod)==2)/* ha a 2.char is stimmel, cserelunk */
					mprogram[k][0]=(2<<8)+kod[1],mprogram[k][1]=sorrend[i]%*codsn;
				else					/* ha a 2.char is o.k., akkor tovabb */
					mprogram[k][0]=(1<<8)+kod[1],mprogram[k][1]=0;
				/* utana teszunk egy nemtalalt-at */
				mprogram[k+1][0]=0,mprogram[k+1][1]=0;
				MPFree=k+2;					/* szabad csak az utana levo */
			}
		}
	}
/*	printf("elso menet kesz.\n"); */
/* elso menet kesz, megyunk tovabb */
/* megnezzuk, legfeljebb milyen hosszuak a kodok */
	for (maxcodlen=0,i=0;i<codn;i++)
		if ((j=strlen((char*)incod[i]))>maxcodlen)
			maxcodlen=j;
/* minden koddal vegezni kell */
	for (h=2;h<maxcodlen;h++)
		for (i=0;i<codn;i++)
		{
			byte *kod;
			int k,l,m;

			kod=incod[sorrend[i]];
			if ((strlen((char*)kod)>=h)&&(strcmp("ss",(char*)kod)))
			{
				l=kod[0];	/* kiindulunk az elso karakterbol, */
				for (k=1;k<h;k++)	/* az direkt ugras */
				{
					l=mprogram[l][1];	/* ide ugrik a prog. szerint */
					for (m=l;
						(((mprogram[m][0]&0xFF)!=kod[k])||
						((mprogram[m][0]>>8)!=1))&&(mprogram[m][0]!=0);
						m++)
						;	/* megkeressuk, hol van a kov. ugras */
					l=m;
				}
				if (mprogram[l][0]!=0)		/* meg nem ert itt veget minden*/
				{
					if (mprogram[l][1]!=0)		/* mar foglalkoztunk az esettel */
					{
						l=mprogram[l][1];		/* megnezzuk, hova ugrik */
						while (mprogram[l][0]!=0)	/* elmegyunk ott a vegeig */
							l++;
					}
					else
					{
						mprogram[l][1]=MPFree;		/* atallitjuk az ugrast */
						l=MPFree++;
					}
					if (strlen((char*)kod)==h)			/* csak akkor cserelunk, ha */
												/* a hosszabb kodok nem jok */
						mprogram[l][0]=(4<<8),mprogram[l][1]=sorrend[i];
					else if (strlen((char*)kod)==h+1)	/* ez mar a kod vege */
						mprogram[l][0]=(2<<8)+kod[h],
						mprogram[l][1]=sorrend[i]%*codsn;
					else					/* me'g majd tovabbmegyunk */
						mprogram[l][0]=(1<<8)+kod[h],mprogram[l][1]=0;
					mprogram[l+1][0]=0,mprogram[l+1][1]=0;
					MPFree=l+2;
				}
			}
		}
	MProgSize=MPFree;
	free((char*)incod[0]);			/* felszabaditjuk... */
	free((char*)incod);
	return 0;
}
