#ifndef W95LFN_H
#define W95LFN_H

#include<stdio.h>
#include<fcntl.h>
#include<errno.h>

#ifdef __MSDOS__
#include<dos.h>
#include<io.h>
#endif

int w95open(const char *path, int access);
int w95move(const char *path, const char *newpath);
int w95delete(const char *path);

/*Int 21 Fn 71  - Windows95 - Long Filename Functions
   AH = 71h
   AL = function
       41h delete file (see AX=7141h)
       56h move (rename) file (see AX=7156h)
       6Ch create/open file (see AX=716Ch)
       ... and others

Return: CF set on error
       AX = error code (see #01657)
       7100h if function not supported
   CF clear if successful
       other registers as for corresponding "old" DOS function
*/

#endif
