Summary: A "hello, world" program
Name: hello3
Version: 3.0
Release: 0
License: public domain
Vendor: Gipsz Jakab <gipsz@ingyenposta.hu>
Group: Applications/Text
Source: %{name}_%{version}-%{release}.tar.gz
URL: http://www.lysator.liu.se/c/bwk-tutor.html
BuildRoot: %{_tmppath}/%{name}-%{version}
Provides: hello
Conflicts: hello
Requires: libhello3 = %{version}

%description
An implementation of the standard "hello, world" program
specially made for Project IPSZILON. See (in Hungarian)
http://ipszilon.iif.hu for poject details.

Webpage of original source: http://www.lysator.liu.se/c/bwk-tutor.html

%package -n libhello3
Group: System Environment/Libraries
Summary: A shared library provides popular hello(3) function.

%description -n libhello3
This package provides shared library contains the popular hello(3) function
for programs need to print "hello, word" message.

%package -n libhello3-devel
Group: Development/Libraries
Summary: Header files and static library for libhello3 package.
Requires: libhello3 = %{version}

%description -n libhello3-devel
Headers and static library for use when compiling programs with
hello2.

%prep
%setup

%build
make

%install
mkdir -p %{buildroot}%{_prefix}
%makeinstall

%clean
rm -rf %{buildroot}

%post -n libhello3
/sbin/ldconfig

%postun -n libhello3
/sbin/ldconfig

%files
%defattr(0644, root, root, 0755)
%attr(0755, root, root) %{_bindir}/hello

%files -n libhello3
%defattr(0644, root, root, 0755)
%attr(0755, root, root) %{_libdir}/libhello.so.*

%files -n libhello3-devel
%defattr(0644, root, root, 0755)
%attr(0755, root, root) %{_libdir}/libhello.so
%{_libdir}/libhello.a
%{_mandir}/man3/hello.3.gz

%changelog
* Mon Feb 05 2006 Gipsz Jakab <gipsz@ingyenposta.hu>
- Initial package.
